From 30832dbade95f89ac502e8e81ef6e0ddbcd67d92 Mon Sep 17 00:00:00 2001
From: Robert Haas <rhaas@postgresql.org>
Date: Fri, 14 Aug 2015 18:47:09 -0400
Subject: [PATCH 2/3] Specify permutations for isolation tests with "invalid"
 permutations.

---
 src/test/isolation/expected/aborted-keyrevoke.out  |   60 -
 .../isolation/expected/aborted-keyrevoke_2.out     |   60 -
 src/test/isolation/expected/alter-table-1.out      | 1304 +++-----------------
 src/test/isolation/expected/alter-table-2.out      |  551 ---------
 src/test/isolation/expected/alter-table-3.out      |  258 ----
 src/test/isolation/expected/create-trigger.out     |  110 --
 .../isolation/expected/delete-abort-savept.out     |  132 --
 src/test/isolation/expected/fk-deadlock.out        |   42 -
 src/test/isolation/expected/fk-deadlock2.out       |   59 -
 src/test/isolation/expected/fk-deadlock2_1.out     |   59 -
 src/test/isolation/expected/fk-deadlock2_2.out     |   59 -
 src/test/isolation/expected/fk-deadlock_1.out      |   42 -
 src/test/isolation/specs/aborted-keyrevoke.spec    |   15 +
 src/test/isolation/specs/alter-table-1.spec        |  138 +++
 src/test/isolation/specs/alter-table-2.spec        |   49 +
 src/test/isolation/specs/alter-table-3.spec        |   49 +
 src/test/isolation/specs/create-trigger.spec       |   26 +
 src/test/isolation/specs/delete-abort-savept.spec  |    8 +
 src/test/isolation/specs/fk-deadlock.spec          |   15 +
 src/test/isolation/specs/fk-deadlock2.spec         |   12 +
 20 files changed, 515 insertions(+), 2533 deletions(-)

diff --git a/src/test/isolation/specs/aborted-keyrevoke.spec b/src/test/isolation/specs/aborted-keyrevoke.spec
index c60aa0c..08945d8 100644
--- a/src/test/isolation/specs/aborted-keyrevoke.spec
+++ b/src/test/isolation/specs/aborted-keyrevoke.spec
@@ -29,3 +29,18 @@ session "s2"
 setup		{ BEGIN; }
 step "s2l"	{ SELECT * FROM foo FOR KEY SHARE; }
 step "s2c"	{ COMMIT; }
+
+permutation "s1s" "s1u" "s1r" "s1l" "s1c" "s2l" "s2c"
+permutation "s1s" "s1u" "s1r" "s1l" "s2l" "s1c" "s2c"
+permutation "s1s" "s1u" "s1r" "s1l" "s2l" "s2c" "s1c"
+permutation "s1s" "s1u" "s1r" "s2l" "s1l" "s1c" "s2c"
+permutation "s1s" "s1u" "s1r" "s2l" "s1l" "s2c" "s1c"
+permutation "s1s" "s1u" "s1r" "s2l" "s2c" "s1l" "s1c"
+permutation "s1s" "s1u" "s2l" "s1r" "s1l" "s1c" "s2c"
+permutation "s1s" "s1u" "s2l" "s1r" "s1l" "s2c" "s1c"
+permutation "s1s" "s1u" "s2l" "s1r" "s2c" "s1l" "s1c"
+permutation "s1s" "s2l" "s1u" "s2c" "s1r" "s1l" "s1c"
+permutation "s1s" "s2l" "s2c" "s1u" "s1r" "s1l" "s1c"
+permutation "s2l" "s1s" "s1u" "s2c" "s1r" "s1l" "s1c"
+permutation "s2l" "s1s" "s2c" "s1u" "s1r" "s1l" "s1c"
+permutation "s2l" "s2c" "s1s" "s1u" "s1r" "s1l" "s1c"
diff --git a/src/test/isolation/specs/alter-table-1.spec b/src/test/isolation/specs/alter-table-1.spec
index 6b38dc1..10e463f 100644
--- a/src/test/isolation/specs/alter-table-1.spec
+++ b/src/test/isolation/specs/alter-table-1.spec
@@ -30,3 +30,141 @@ step "rx1"	{ SELECT * FROM b WHERE a_id = 1 LIMIT 1; }
 step "wx"	{ INSERT INTO b VALUES (0); }
 step "rx3"	{ SELECT * FROM b WHERE a_id = 3 LIMIT 3; }
 step "c2"	{ COMMIT; }
+
+permutation "s1" "at1" "sc1" "s2" "at2" "sc2" "rx1" "wx" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "at2" "rx1" "sc2" "wx" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "at2" "rx1" "wx" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "at2" "rx1" "wx" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "s2" "at2" "rx1" "wx" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "at2" "sc2" "wx" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "at2" "wx" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "at2" "wx" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "at2" "wx" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "sc1" "s2" "rx1" "wx" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "at2" "sc2" "wx" "rx3" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "at2" "wx" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "at2" "wx" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "at2" "wx" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "s2" "wx" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "s2" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "rx3" "s2" "at2" "sc2" "c2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "rx3" "s2" "at2" "c2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "rx3" "s2" "c2" "at2" "sc2"
+permutation "s1" "at1" "sc1" "rx1" "wx" "rx3" "c2" "s2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "at2" "sc2" "wx" "rx3" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "at2" "wx" "sc2" "rx3" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "at2" "wx" "rx3" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "at2" "wx" "rx3" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "s2" "wx" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "s2" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "rx3" "s2" "at2" "sc2" "c2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "rx3" "s2" "at2" "c2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "rx3" "s2" "c2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "sc1" "wx" "rx3" "c2" "s2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "at2" "sc2" "rx3" "c2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "at2" "rx3" "sc2" "c2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "at2" "rx3" "c2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "rx3" "at2" "sc2" "c2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "rx3" "at2" "c2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "s2" "rx3" "c2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "rx3" "s2" "at2" "sc2" "c2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "rx3" "s2" "at2" "c2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "rx3" "s2" "c2" "at2" "sc2"
+permutation "s1" "at1" "rx1" "wx" "sc1" "rx3" "c2" "s2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "at2" "sc2" "wx" "rx3" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "at2" "wx" "sc2" "rx3" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "at2" "wx" "rx3" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "at2" "wx" "rx3" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "at2" "sc2" "rx3" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "at2" "rx3" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "at2" "rx3" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "rx3" "at2" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "rx3" "at2" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "s2" "wx" "rx3" "c2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "at2" "sc2" "rx3" "c2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "at2" "rx3" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "at2" "rx3" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "rx3" "at2" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "rx3" "at2" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "s2" "rx3" "c2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "rx3" "s2" "at2" "sc2" "c2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "rx3" "s2" "at2" "c2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "rx3" "s2" "c2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "sc1" "wx" "rx3" "c2" "s2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "at2" "sc2" "rx3" "c2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "at2" "rx3" "sc2" "c2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "at2" "rx3" "c2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "rx3" "at2" "sc2" "c2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "rx3" "at2" "c2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "s2" "rx3" "c2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "rx3" "s2" "at2" "sc2" "c2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "rx3" "s2" "at2" "c2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "rx3" "s2" "c2" "at2" "sc2"
+permutation "s1" "rx1" "at1" "wx" "sc1" "rx3" "c2" "s2" "at2" "sc2"
+permutation "s1" "rx1" "wx" "at1" "rx3" "c2" "sc1" "s2" "at2" "sc2"
+permutation "s1" "rx1" "wx" "rx3" "at1" "c2" "sc1" "s2" "at2" "sc2"
+permutation "s1" "rx1" "wx" "rx3" "c2" "at1" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "at2" "sc2" "wx" "rx3" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "at2" "wx" "sc2" "rx3" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "at2" "wx" "rx3" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "at2" "wx" "rx3" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "at2" "sc2" "rx3" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "at2" "rx3" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "at2" "rx3" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "rx3" "at2" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "rx3" "at2" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "s2" "wx" "rx3" "c2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "at2" "sc2" "rx3" "c2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "at2" "rx3" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "at2" "rx3" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "rx3" "at2" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "rx3" "at2" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "s2" "rx3" "c2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "rx3" "s2" "at2" "sc2" "c2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "rx3" "s2" "at2" "c2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "rx3" "s2" "c2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "sc1" "wx" "rx3" "c2" "s2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "at2" "sc2" "rx3" "c2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "at2" "rx3" "sc2" "c2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "at2" "rx3" "c2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "rx3" "at2" "sc2" "c2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "rx3" "at2" "c2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "s2" "rx3" "c2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "rx3" "s2" "at2" "sc2" "c2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "rx3" "s2" "at2" "c2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "rx3" "s2" "c2" "at2" "sc2"
+permutation "rx1" "s1" "at1" "wx" "sc1" "rx3" "c2" "s2" "at2" "sc2"
+permutation "rx1" "s1" "wx" "at1" "rx3" "c2" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "s1" "wx" "rx3" "at1" "c2" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "s1" "wx" "rx3" "c2" "at1" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "s1" "at1" "rx3" "c2" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "s1" "rx3" "at1" "c2" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "s1" "rx3" "c2" "at1" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "rx3" "s1" "at1" "c2" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "rx3" "s1" "c2" "at1" "sc1" "s2" "at2" "sc2"
+permutation "rx1" "wx" "rx3" "c2" "s1" "at1" "sc1" "s2" "at2" "sc2"
diff --git a/src/test/isolation/specs/alter-table-2.spec b/src/test/isolation/specs/alter-table-2.spec
index e6a02e0..9b17992 100644
--- a/src/test/isolation/specs/alter-table-2.spec
+++ b/src/test/isolation/specs/alter-table-2.spec
@@ -28,3 +28,52 @@ step "s2c" { SELECT * FROM b WHERE a_id = 3 LIMIT 1 FOR UPDATE; }
 step "s2d" { INSERT INTO b VALUES (0); }
 step "s2e" { INSERT INTO a VALUES (4); }
 step "s2f" { COMMIT; }
+
+permutation "s1a" "s1b" "s1c" "s2a" "s2b" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s1b" "s2a" "s1c" "s2b" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s1b" "s2a" "s2b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s1b" "s2a" "s2b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s1a" "s1b" "s2a" "s2b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s1a" "s2a" "s1b" "s1c" "s2b" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s1b" "s2b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s1b" "s2b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s1b" "s2b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s1b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s1b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s1b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s1c" "s2d" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s2d" "s1c" "s2e" "s2f"
+permutation "s1a" "s2a" "s2b" "s2c" "s2d" "s1b" "s2e" "s2f" "s1c"
+permutation "s1a" "s2a" "s2b" "s2c" "s2d" "s2e" "s1b" "s2f" "s1c"
+permutation "s1a" "s2a" "s2b" "s2c" "s2d" "s2e" "s2f" "s1b" "s1c"
+permutation "s2a" "s1a" "s1b" "s1c" "s2b" "s2c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s1b" "s2b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s1b" "s2b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s1b" "s2b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s1b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s1b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s1b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s1a" "s2b" "s2c" "s2d" "s1b" "s2e" "s2f" "s1c"
+permutation "s2a" "s1a" "s2b" "s2c" "s2d" "s2e" "s1b" "s2f" "s1c"
+permutation "s2a" "s1a" "s2b" "s2c" "s2d" "s2e" "s2f" "s1b" "s1c"
+permutation "s2a" "s2b" "s1a" "s1b" "s1c" "s2c" "s2d" "s2e" "s2f"
+permutation "s2a" "s2b" "s1a" "s1b" "s2c" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s2b" "s1a" "s1b" "s2c" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s2b" "s1a" "s2c" "s2d" "s1b" "s2e" "s2f" "s1c"
+permutation "s2a" "s2b" "s1a" "s2c" "s2d" "s2e" "s1b" "s2f" "s1c"
+permutation "s2a" "s2b" "s1a" "s2c" "s2d" "s2e" "s2f" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s1c" "s2d" "s2e" "s2f"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s2d" "s1c" "s2e" "s2f"
+permutation "s2a" "s2b" "s2c" "s1a" "s2d" "s1b" "s2e" "s2f" "s1c"
+permutation "s2a" "s2b" "s2c" "s1a" "s2d" "s2e" "s1b" "s2f" "s1c"
+permutation "s2a" "s2b" "s2c" "s1a" "s2d" "s2e" "s2f" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s1a" "s1b" "s2e" "s2f" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s1a" "s2e" "s1b" "s2f" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s1a" "s2e" "s2f" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s2e" "s1a" "s1b" "s2f" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s2e" "s1a" "s2f" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s2e" "s2f" "s1a" "s1b" "s1c"
diff --git a/src/test/isolation/specs/alter-table-3.spec b/src/test/isolation/specs/alter-table-3.spec
index d252620..d07e3dd 100644
--- a/src/test/isolation/specs/alter-table-3.spec
+++ b/src/test/isolation/specs/alter-table-3.spec
@@ -28,3 +28,52 @@ step "s2a" { BEGIN; }
 step "s2b" { SELECT * FROM a WHERE i = 1 LIMIT 1 FOR UPDATE; }
 step "s2c" { INSERT INTO a VALUES (0); }
 step "s2d" { COMMIT; }
+
+permutation "s1a" "s1b" "s1c" "s1d" "s2a" "s2b" "s2c" "s2d"
+permutation "s1a" "s1b" "s1c" "s2a" "s1d" "s2b" "s2c" "s2d"
+permutation "s1a" "s1b" "s1c" "s2a" "s2b" "s1d" "s2c" "s2d"
+permutation "s1a" "s1b" "s1c" "s2a" "s2b" "s2c" "s1d" "s2d"
+permutation "s1a" "s1b" "s2a" "s1c" "s1d" "s2b" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s1c" "s2b" "s1d" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s1c" "s2b" "s2c" "s1d" "s2d"
+permutation "s1a" "s1b" "s2a" "s2b" "s1c" "s1d" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s2b" "s1c" "s2c" "s1d" "s2d"
+permutation "s1a" "s1b" "s2a" "s2b" "s2c" "s1c" "s1d" "s2d"
+permutation "s1a" "s2a" "s1b" "s1c" "s1d" "s2b" "s2c" "s2d"
+permutation "s1a" "s2a" "s1b" "s1c" "s2b" "s1d" "s2c" "s2d"
+permutation "s1a" "s2a" "s1b" "s1c" "s2b" "s2c" "s1d" "s2d"
+permutation "s1a" "s2a" "s1b" "s2b" "s1c" "s1d" "s2c" "s2d"
+permutation "s1a" "s2a" "s1b" "s2b" "s1c" "s2c" "s1d" "s2d"
+permutation "s1a" "s2a" "s1b" "s2b" "s2c" "s1c" "s1d" "s2d"
+permutation "s1a" "s2a" "s2b" "s1b" "s1c" "s1d" "s2c" "s2d"
+permutation "s1a" "s2a" "s2b" "s1b" "s1c" "s2c" "s1d" "s2d"
+permutation "s1a" "s2a" "s2b" "s1b" "s2c" "s1c" "s1d" "s2d"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s1c" "s1d" "s2d"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s1c" "s2d" "s1d"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s2d" "s1c" "s1d"
+permutation "s1a" "s2a" "s2b" "s2c" "s2d" "s1b" "s1c" "s1d"
+permutation "s2a" "s1a" "s1b" "s1c" "s1d" "s2b" "s2c" "s2d"
+permutation "s2a" "s1a" "s1b" "s1c" "s2b" "s1d" "s2c" "s2d"
+permutation "s2a" "s1a" "s1b" "s1c" "s2b" "s2c" "s1d" "s2d"
+permutation "s2a" "s1a" "s1b" "s2b" "s1c" "s1d" "s2c" "s2d"
+permutation "s2a" "s1a" "s1b" "s2b" "s1c" "s2c" "s1d" "s2d"
+permutation "s2a" "s1a" "s1b" "s2b" "s2c" "s1c" "s1d" "s2d"
+permutation "s2a" "s1a" "s2b" "s1b" "s1c" "s1d" "s2c" "s2d"
+permutation "s2a" "s1a" "s2b" "s1b" "s1c" "s2c" "s1d" "s2d"
+permutation "s2a" "s1a" "s2b" "s1b" "s2c" "s1c" "s1d" "s2d"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s1c" "s1d" "s2d"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s1c" "s2d" "s1d"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s2d" "s1c" "s1d"
+permutation "s2a" "s1a" "s2b" "s2c" "s2d" "s1b" "s1c" "s1d"
+permutation "s2a" "s2b" "s1a" "s1b" "s1c" "s1d" "s2c" "s2d"
+permutation "s2a" "s2b" "s1a" "s1b" "s1c" "s2c" "s1d" "s2d"
+permutation "s2a" "s2b" "s1a" "s1b" "s2c" "s1c" "s1d" "s2d"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s1c" "s1d" "s2d"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s1c" "s2d" "s1d"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s2d" "s1c" "s1d"
+permutation "s2a" "s2b" "s1a" "s2c" "s2d" "s1b" "s1c" "s1d"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s1c" "s1d" "s2d"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s1c" "s2d" "s1d"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s2d" "s1c" "s1d"
+permutation "s2a" "s2b" "s2c" "s1a" "s2d" "s1b" "s1c" "s1d"
+permutation "s2a" "s2b" "s2c" "s2d" "s1a" "s1b" "s1c" "s1d"
diff --git a/src/test/isolation/specs/create-trigger.spec b/src/test/isolation/specs/create-trigger.spec
index 34fad75..caac381 100644
--- a/src/test/isolation/specs/create-trigger.spec
+++ b/src/test/isolation/specs/create-trigger.spec
@@ -26,3 +26,29 @@ step "s2a" { BEGIN; }
 step "s2b" { SELECT * FROM a WHERE i = 1 FOR UPDATE; }
 step "s2c" { UPDATE a SET i = 4 WHERE i = 3; }
 step "s2d" { COMMIT; }
+
+permutation "s1a" "s1b" "s1c" "s2a" "s2b" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s1c" "s2b" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s2b" "s1c" "s2c" "s2d"
+permutation "s1a" "s1b" "s2a" "s2b" "s2c" "s1c" "s2d"
+permutation "s1a" "s2a" "s1b" "s1c" "s2b" "s2c" "s2d"
+permutation "s1a" "s2a" "s1b" "s2b" "s1c" "s2c" "s2d"
+permutation "s1a" "s2a" "s1b" "s2b" "s2c" "s1c" "s2d"
+permutation "s1a" "s2a" "s2b" "s1b" "s1c" "s2c" "s2d"
+permutation "s1a" "s2a" "s2b" "s1b" "s2c" "s1c" "s2d"
+permutation "s1a" "s2a" "s2b" "s2c" "s1b" "s2d" "s1c"
+permutation "s1a" "s2a" "s2b" "s2c" "s2d" "s1b" "s1c"
+permutation "s2a" "s1a" "s1b" "s1c" "s2b" "s2c" "s2d"
+permutation "s2a" "s1a" "s1b" "s2b" "s1c" "s2c" "s2d"
+permutation "s2a" "s1a" "s1b" "s2b" "s2c" "s1c" "s2d"
+permutation "s2a" "s1a" "s2b" "s1b" "s1c" "s2c" "s2d"
+permutation "s2a" "s1a" "s2b" "s1b" "s2c" "s1c" "s2d"
+permutation "s2a" "s1a" "s2b" "s2c" "s1b" "s2d" "s1c"
+permutation "s2a" "s1a" "s2b" "s2c" "s2d" "s1b" "s1c"
+permutation "s2a" "s2b" "s1a" "s1b" "s1c" "s2c" "s2d"
+permutation "s2a" "s2b" "s1a" "s1b" "s2c" "s1c" "s2d"
+permutation "s2a" "s2b" "s1a" "s2c" "s1b" "s2d" "s1c"
+permutation "s2a" "s2b" "s1a" "s2c" "s2d" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s1a" "s1b" "s2d" "s1c"
+permutation "s2a" "s2b" "s2c" "s1a" "s2d" "s1b" "s1c"
+permutation "s2a" "s2b" "s2c" "s2d" "s1a" "s1b" "s1c"
diff --git a/src/test/isolation/specs/delete-abort-savept.spec b/src/test/isolation/specs/delete-abort-savept.spec
index e41df20..bc32e21 100644
--- a/src/test/isolation/specs/delete-abort-savept.spec
+++ b/src/test/isolation/specs/delete-abort-savept.spec
@@ -27,3 +27,11 @@ session "s2"
 setup			{ BEGIN; }
 step "s2l"		{ SELECT * FROM foo FOR UPDATE; }
 step "s2c"		{ COMMIT; }
+
+permutation "s1l" "s1svp" "s1d" "s1r" "s1c" "s2l" "s2c"
+permutation "s1l" "s1svp" "s1d" "s1r" "s2l" "s1c" "s2c"
+permutation "s1l" "s1svp" "s1d" "s2l" "s1r" "s1c" "s2c"
+permutation "s1l" "s1svp" "s2l" "s1d" "s1r" "s1c" "s2c"
+permutation "s1l" "s2l" "s1svp" "s1d" "s1r" "s1c" "s2c"
+permutation "s2l" "s1l" "s2c" "s1svp" "s1d" "s1r" "s1c"
+permutation "s2l" "s2c" "s1l" "s1svp" "s1d" "s1r" "s1c"
diff --git a/src/test/isolation/specs/fk-deadlock.spec b/src/test/isolation/specs/fk-deadlock.spec
index 44500d5..4f357c6 100644
--- a/src/test/isolation/specs/fk-deadlock.spec
+++ b/src/test/isolation/specs/fk-deadlock.spec
@@ -29,3 +29,18 @@ setup		{ BEGIN; SET deadlock_timeout = '10s'; }
 step "s2i"	{ INSERT INTO child VALUES (2, 1); }
 step "s2u"	{ UPDATE parent SET aux = 'baz'; }
 step "s2c"	{ COMMIT; }
+
+permutation "s1i" "s1u" "s1c" "s2i" "s2u" "s2c"
+permutation "s1i" "s1u" "s2i" "s1c" "s2u" "s2c"
+permutation "s1i" "s1u" "s2i" "s2u" "s1c" "s2c"
+permutation "s1i" "s2i" "s1u" "s1c" "s2u" "s2c"
+permutation "s1i" "s2i" "s1u" "s2u" "s1c" "s2c"
+permutation "s1i" "s2i" "s2u" "s1u" "s2c" "s1c"
+permutation "s1i" "s2i" "s2u" "s2c" "s1u" "s1c"
+permutation "s2i" "s1i" "s1u" "s1c" "s2u" "s2c"
+permutation "s2i" "s1i" "s1u" "s2u" "s1c" "s2c"
+permutation "s2i" "s1i" "s2u" "s1u" "s2c" "s1c"
+permutation "s2i" "s1i" "s2u" "s2c" "s1u" "s1c"
+permutation "s2i" "s2u" "s1i" "s1u" "s2c" "s1c"
+permutation "s2i" "s2u" "s1i" "s2c" "s1u" "s1c"
+permutation "s2i" "s2u" "s2c" "s1i" "s1u" "s1c"
diff --git a/src/test/isolation/specs/fk-deadlock2.spec b/src/test/isolation/specs/fk-deadlock2.spec
index f500b26..a830524 100644
--- a/src/test/isolation/specs/fk-deadlock2.spec
+++ b/src/test/isolation/specs/fk-deadlock2.spec
@@ -34,3 +34,15 @@ setup		{ BEGIN; SET deadlock_timeout = '10s'; }
 step "s2u1"	{ UPDATE B SET Col2 = 1 WHERE BID = 2; }
 step "s2u2"	{ UPDATE B SET Col2 = 1 WHERE BID = 2; }
 step "s2c"	{ COMMIT; }
+
+permutation "s1u1" "s1u2" "s1c" "s2u1" "s2u2" "s2c"
+permutation "s1u1" "s1u2" "s2u1" "s1c" "s2u2" "s2c"
+permutation "s1u1" "s2u1" "s1u2" "s2u2" "s2c" "s1c"
+permutation "s1u1" "s2u1" "s2u2" "s1u2" "s2c" "s1c"
+permutation "s1u1" "s2u1" "s2u2" "s2c" "s1u2" "s1c"
+permutation "s2u1" "s1u1" "s1u2" "s2u2" "s2c" "s1c"
+permutation "s2u1" "s1u1" "s2u2" "s1u2" "s2c" "s1c"
+permutation "s2u1" "s1u1" "s2u2" "s2c" "s1u2" "s1c"
+permutation "s2u1" "s2u2" "s1u1" "s1u2" "s2c" "s1c"
+permutation "s2u1" "s2u2" "s1u1" "s2c" "s1u2" "s1c"
+permutation "s2u1" "s2u2" "s2c" "s1u1" "s1u2" "s1c"
-- 
2.3.2 (Apple Git-55)

